import os

# Error messages
ALGO_WRAP_ERR = "Error in AlgoWrapper"
ALGO_WRAP_ERR_INVALID_INP = "Error in AlgoWrapper. Invalid Input"
BASE_ERR = "An Error has occured"
CORNA_PACK_ERR = "Error running CORNA package"
HTTP_REQ_ERR = "HTTPRequestError has occured"
INPUT_ERR = "Error while downloading input of algorithm"
INPUT_URLS = "Input Urls: "
LOG_PACK_S3_ERR = "Cannot fetch log package list from s3."
LOG_UPLOAD_ERR = 'Error while uploading error.log'
NA_CORR_ERR = "Error in NA Correction"
OUTPUT_FTYPES = "Output file types: "
PARAM_JSON = "Parameter json: "
RDS_WRITE_FAIL = "Failed to write to RDS."
S3_ERR = "An S3 operational error has occured"
SOME_ERROR = "Some error has occured."
URL_WILDCARD_REPL_ERR = "Url and the replacer for the wildcard do not match."
UPLOAD_ERR = "Error while uploading the output of algorithm"

# AWS Constants/Update messages
COMP_TASK = "completed"
CREDENTIALS = "credentials"
DOWN_FILES = "download_filename"
HEARTBEAT = "heartbeat"
ID = "id"
ITER_ID = " Iter ID: "
ITERATION = "iteration"
INPUT_STATE = "input"
JSON_HEAD = {'content-type': 'application/json'}
LIST_PACKGES = "List of installed packages and versions: "
LOG_PACKAGES_URL = "https://s3-us-west-2.amazonaws.com/mithoo-public-data/" +\
                    "pip_packages/internal_pip.txt"
PARAM_FILE = "parameter_filename"
PARAM_JSON = "paramater_json"
PASSWORD = "password"
PAYLOAD = "payload"
RESULT = "result"
SEPARAT = os.sep
START_TASK = "task_started"
STATE_STR = "state"
TASK_RECV = "task_recieved"
URLS = "urls"
USER = "user"
RUN_IDFR = "run"
WORKFLOW_REQUEST = 'workflow_request'
DOWNLOAD_JSON_FILE = 'download_filename'

FILE_NAME_IDFR = 'file_name'
URL_IDFR = 'url'
BUCKET_IDFR = 'bucket'

RES_FILE = 'result.json'
ORNT_TYPE = 'records'
PICKLE_IDFR = 'pickle'
COMPRES_IDFR = 'compressed'
SPLIT_IDFR = 'split'
RDS_IDFR = 'rds'
PATH_IDFR = 'path'


# Commands
CMD_CURL_PUT = 'curl --request PUT -H "Content-Type:*/*" --upload-file '
CMD_CURL_PUT_RETRY = 'curl --connect-timeout 5 --max-time 10 --retry 5 --retry-delay 0 --retry-max-time 60 ' \
                      + '--request PUT -H "Content-Type:*/*" --upload-file '


COMP_TASK = "completed"
ALGORITHM_KEY = "algorithm"
PARAMETER_JSON = "PARAMETER_JSON"
USER_INPUT_IDENTIFIER = 'user_files'
UPLOAD_INPUT = 'Upload_to_input'

# iteration types
ITER_WORKFLOW = 'workflow'
ITER_COMPONENT = 'component'

# error Message
INVALID_ITER = "invalid iteration Type"
LOG_FILE_NAME = 'error.log'


# Debug Constants
USER_INFO = 'User Info: '

PARAM_KEY = 'parameter_file'

# Output formate Keyword
OUTPUT_FORMAT = "format"
ZIP = "zip"
UNZIP = "unzip"
ZIP_EXTENSION = ".zip"
